/*
 *	Name:		dump
 *	Function:	Dumps the contents of a file or stdin in hex
 *
 *	Author:		Peter van der Veen
 *	Date:		March 2, 1991
 */

#include <stdio.h>
#include <stdlib.h>

void main(int argc, char *argv[]) {
	FILE	*fp;
	long	start = 0,
			end = -1,
			n;
	int		c;
	int		count = 0;
	char	ch[17];

	if(need_usage(argv)) {
		printf("use: dump [file [start [end]]]\n");
		exit(EXIT_SUCCESS);
	}
	fp = stdin;
	if(argc > 1) {
		if(!(fp = fopen(argv[1], "r"))) {
			fprintf(stderr, "Unable to open '%s'\n", argv[1]);
			exit(EXIT_FAILURE);
		}
	} else {
		fp = stdin;
	}
	if(argc > 2) start = atol(argv[2]);
	if(argc > 3) end = atol(argv[3]);

	for(n = 0; n < start; n++) {
		if(getc(fp) == EOF) {
			fprintf(stderr, "End of File reached\n");
			exit(EXIT_FAILURE);
		}
	}
	
	while((c = getc(fp)) != EOF) {
		if((end != -1) && (start > end)) break;
		if(!count) {
			printf("%09ld: ", start);
			strcpy(ch, "................");
		}
		start++;
		printf(" %02x", c);
		if(isprint(c)) ch[count] = (char)c;
		if(count == 7) putchar(' ');
		if(++count == 16) {
			printf("   %s\n", ch);
			count = 0;
		}
	}
	if(count) {
		while(count < 16) {
			if(count == 8) putchar(' ');
			ch[count++] = '-';
			printf(" --");
		}
		printf("   %s\n", ch);
	}
	if(argc > 1) fclose(fp);
	exit(EXIT_SUCCESS);
}
